/* ============================================================================================== *
 *                                                                                                *
 *                                       Xi Blockchain                                            *
 *                                                                                                *
 * ---------------------------------------------------------------------------------------------- *
 * This file is part of the Galaxia Project - Xi Blockchain                                       *
 * ---------------------------------------------------------------------------------------------- *
 *                                                                                                *
 * Copyright 2018-2019 Galaxia Project Developers                                                 *
 *                                                                                                *
 * This program is free software: you can redistribute it and/or modify it under the terms of the *
 * GNU General Public License as published by the Free Software Foundation, either version 3 of   *
 * the License, or (at your option) any later version.                                            *
 *                                                                                                *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;      *
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      *
 * See the GNU General Public License for more details.                                           *
 *                                                                                                *
 * You should have received a copy of the GNU General Public License along with this program.     *
 * If not, see <https://www.gnu.org/licenses/>.                                                   *
 *                                                                                                *
 * ============================================================================================== */

#include <gmock/gmock.h>

#include <Xi/Rct/Constants.h>
#include <Xi/Rct/Algorithm/KeyArithmetic.h>

#define XI_TESTSUITE T_Xi_Rct_KeyArithmetic

TEST(XI_TESTSUITE, SumPointVector) {
  using namespace ::testing;
  using namespace ::Xi;
  using namespace ::Xi::Rct;

  std::vector<std::pair<KeyVector, Rct::Key>> Oracle{{
      {{{{{0xe9, 0x76, 0x4a, 0xa7, 0xd,  0xd7, 0xde, 0x4a, 0x99, 0xed, 0x76, 0x42, 0x13, 0x48, 0x1b, 0xf3,
           0x23, 0x4a, 0x65, 0xcf, 0x47, 0xdc, 0x1a, 0x7c, 0x43, 0x7,  0xb4, 0xbf, 0x52, 0x9f, 0xc9, 0x92}},
         {{0x69, 0x8b, 0x6e, 0x7c, 0x82, 0xe9, 0xb4, 0xa5, 0xc9, 0xb4, 0x95, 0x35, 0xa1, 0x3e, 0xb9, 0x7b,
           0xd5, 0x49, 0x81, 0x5e, 0xd3, 0x4a, 0x1c, 0x95, 0xd0, 0x9b, 0x41, 0x1d, 0x46, 0xba, 0x98, 0x76}}}},
       {{0x9d, 0x1d, 0x6d, 0xca, 0x77, 0x4c, 0x19, 0x6b, 0x6d, 0xf3, 0xd0, 0x2,  0xc9, 0xb8, 0x84, 0x60,
         0xfe, 0xca, 0x73, 0xf8, 0x81, 0x21, 0x7f, 0xfe, 0x7e, 0x96, 0x3b, 0x57, 0xba, 0x6b, 0x3a, 0x71}}},

      {{{{{0xa2, 0x84, 0x39, 0x7d, 0xc9, 0x4,  0xd3, 0xb3, 0xb7, 0x46, 0xca, 0x5a, 0x42, 0xc,  0xf5, 0x18,
           0x28, 0x8c, 0x9,  0xfb, 0xc,  0x2c, 0x81, 0xe6, 0x53, 0x88, 0x2c, 0x7f, 0x1f, 0xfa, 0x5f, 0x32}},
         {{0x28, 0xe8, 0x2f, 0x1f, 0xea, 0x7b, 0xa,  0xd4, 0x5c, 0xe6, 0x68, 0xa4, 0x16, 0x26, 0x3a, 0x83,
           0x4c, 0x45, 0xe1, 0x4a, 0x6c, 0xc8, 0x30, 0xb7, 0xef, 0x71, 0xb2, 0x50, 0x92, 0x9,  0x5b, 0xd4}}}},
       {{0x96, 0x65, 0xf5, 0x16, 0x3f, 0xd9, 0xc,  0xe9, 0x5c, 0x93, 0x4b, 0xcf, 0x61, 0xc0, 0xcf, 0x60,
         0x4e, 0x3c, 0xf5, 0xf8, 0xb2, 0x37, 0xf6, 0x92, 0x88, 0xeb, 0x0,  0xed, 0x61, 0x18, 0xf7, 0x7e}}},

      {{{{{0x1e, 0xc6, 0x41, 0xed, 0xdc, 0xde, 0xa3, 0x39, 0xd8, 0x1,  0x21, 0x48, 0x27, 0x45, 0xbc, 0x54,
           0xb1, 0xa5, 0xee, 0x32, 0xf3, 0x7b, 0x4e, 0x1,  0x2,  0x72, 0xf6, 0xd4, 0x1a, 0x49, 0x89, 0x37}},
         {{0x56, 0xe, 0xa,  0x33, 0x53, 0xaa, 0x38, 0x4d, 0x1f, 0xc6, 0x4e, 0x6f, 0x9e, 0x5,  0xfc, 0x8b,
           0x1e, 0x0, 0x76, 0x72, 0x3b, 0x1f, 0xf1, 0x95, 0x4,  0x58, 0x8d, 0x29, 0x3,  0x3c, 0x29, 0xa8}}}},
       {{0x32, 0x80, 0xcd, 0x96, 0xce, 0xb1, 0xae, 0x5,  0x7b, 0x5e, 0xc,  0x13, 0x41, 0x6c, 0x9,  0xb5,
         0xce, 0x5b, 0x84, 0x86, 0xcf, 0xcc, 0x21, 0xaa, 0x7c, 0x30, 0x8d, 0x66, 0x6f, 0x31, 0xe2, 0xb}}},

      {{{{{0x2e, 0xab, 0x67, 0xda, 0xe6, 0xa6, 0xde, 0x38, 0xf3, 0xb9, 0x10, 0xce, 0x7b, 0x3d, 0xdf, 0x1a,
           0x20, 0x9d, 0x49, 0xa1, 0xd5, 0xb3, 0xbf, 0x1a, 0x45, 0x70, 0x99, 0xcf, 0x5f, 0x85, 0x1e, 0x8c}},
         {{0xe7, 0xc7, 0xd3, 0xa9, 0x11, 0x5a, 0x99, 0x22, 0x87, 0xae, 0xec, 0x50, 0xd9, 0x21, 0x42, 0x9c,
           0xd7, 0x14, 0x55, 0x3d, 0x1d, 0x61, 0x98, 0x96, 0x7b, 0x69, 0x45, 0x5e, 0x6f, 0x7a, 0xf0, 0xeb}}}},
       {{0x32, 0x80, 0xcd, 0x96, 0xce, 0xb1, 0xae, 0x5,  0x7b, 0x5e, 0xc,  0x13, 0x41, 0x6c, 0x9,  0xb5,
         0xce, 0x5b, 0x84, 0x86, 0xcf, 0xcc, 0x21, 0xaa, 0x7c, 0x30, 0x8d, 0x66, 0x6f, 0x31, 0xe2, 0xb}}},
  }};

  for (const auto& oracle : Oracle) {
    const auto& input = oracle.first;
    const auto& expected = oracle.second;
    auto returnVariant = key_vector_sum(input);
    EXPECT_EQ(returnVariant, expected);
  }
}
